#ifndef EFL_LOOP_FD_EO_HH
#define EFL_LOOP_FD_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_loop.eo.h"
#include "efl_loop_fd.eo.h"
#include "efl_loop_user.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_loop.eo.hh"
#include "efl_loop_user.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace loop { 
struct Fd;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::loop::Fd> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace loop { 
struct Fd {
   ::efl::eolian::return_traits<int>::type fd_get() const;
   ::efl::eolian::return_traits<void>::type fd_set( ::efl::eolian::in_traits<int>::type fd) const;
   ::efl::eolian::return_traits<int>::type fd_file_get() const;
   ::efl::eolian::return_traits<void>::type fd_file_set( ::efl::eolian::in_traits<int>::type fd) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_LOOP_FD_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::loop::Fd() const;
   operator ::efl::loop::Fd&();
   operator ::efl::loop::Fd const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Fd,  ::efl::Loop_User,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Fd const ,  ::efl::Loop_User const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace loop { 
struct Fd : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Loop_User)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Fd( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Fd(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Fd(Fd const& other) = default;
   Fd(Fd&& other) = default;
   Fd& operator=(Fd const& other) = default;
   Fd& operator=(Fd&& other) = default;
   Fd()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Fd( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Fd(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<int>::type fd_get() const;
   ::efl::eolian::return_traits<void>::type fd_set( ::efl::eolian::in_traits<int>::type fd) const;
   ::efl::eolian::return_traits<int>::type fd_file_get() const;
   ::efl::eolian::return_traits<void>::type fd_file_set( ::efl::eolian::in_traits<int>::type fd) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_LOOP_FD_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct read_event
   {
      static Eo_Event_Description const* description()
      { return EFL_LOOP_FD_EVENT_READ; }
      typedef void parameter_type;
   } const read_event;
   static struct write_event
   {
      static Eo_Event_Description const* description()
      { return EFL_LOOP_FD_EVENT_WRITE; }
      typedef void parameter_type;
   } const write_event;
   static struct error_event
   {
      static Eo_Event_Description const* description()
      { return EFL_LOOP_FD_EVENT_ERROR; }
      typedef void parameter_type;
   } const error_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Fd,  ::efl::Loop_User,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Fd const ,  ::efl::Loop_User const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Fd) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Fd>::value, "");
} } 
#include "efl_loop_fd.eo.impl.hh"
#endif
